# Getestet mit Python 3.11.6 und PySide 6.5.3

from typing import Callable
import PySide6.QtWidgets as widgets
import PySide6.QtGui as gui

class MeinWidget(widgets.QWidget):
    def __init__(self, parent : widgets.QWidget|None = None):
        super().__init__(parent)
        self._moveHandler : Callable[[gui.QMouseEvent], None]|None = None
        self._releaseHandler : Callable[[gui.QMouseEvent], None]|None = None

    def setHandlers(self, move: Callable[[gui.QMouseEvent], None], release: Callable[[gui.QMouseEvent], None]) -> None:
        self._moveHandler = move
        self._releaseHandler = release

    def mouseMoveEvent(self, event: gui.QMouseEvent) -> None:
        if self._moveHandler:
            self._moveHandler(event)
        super().mouseMoveEvent(event)

    def mouseReleaseEvent(self, event: gui.QMouseEvent) -> None:
        if self._releaseHandler:
            self._releaseHandler(event)
        super().mouseReleaseEvent(event)