# Getestet mit Python 3.11.6 und PySide 6.5.3

import sys
import csv
import math
import PySide6.QtWidgets as widgets
import PySide6.QtCore as core
import PySide6.QtGui as gui
import PySide6.QtUiTools as uic
from MeinWidget import MeinWidget

app = widgets.QApplication(sys.argv)

loader = uic.QUiLoader()
# In der UI-Datei ist ein QWidget als Platzhalter für unser Widget eingetragen.
# Dazu im Qt Designer Mausklick rechts auf das Widget und als Klasse MeinWidget, als Header MeinWidget.h (!) angeben
loader.registerCustomWidget(MeinWidget)
w = uic.QUiLoader().load("gesten.ui")

training : list[list[core.QPointF]]= []
trainingSchwerpunkte : list[core.QPointF] = []
trainingSD : list[float] = []

f = open("mausgesten.csv", "r")
reader = csv.reader(f, delimiter = ';')
g : list[core.QPointF] = []
xSumme = 0
ySumme = 0
x2Summe = 0
y2Summe = 0
for row in reader:
    if float(row[0]) < 0:
        xm = xSumme / len(g)
        ym = ySumme / len(g)
        trainingSchwerpunkte.append(core.QPointF(xm, ym))
        trainingSD.append(math.sqrt(x2Summe / len(g) - xm * xm + y2Summe / len(g) - ym * ym))
        training.append(g)
        g = []
        xSumme = 0
        ySumme = 0
        x2Summe = 0
        y2Summe = 0        
    else:
        x = float(row[0])
        y = float(row[1])
        g.append(core.QPointF(x, y))
        xSumme += x
        ySumme += y
        x2Summe += x * x
        y2Summe += y * y
f.close()

points : list[core.QPointF] = []

def move(event: gui.QMouseEvent) -> None:
    points.append(event.position())

def release(event: gui.QMouseEvent) -> None:
    xSumme = 0
    ySumme = 0
    x2Summe = 0
    y2Summe = 0
    for p in points:
        xSumme += p.x()
        ySumme += p.y()
        x2Summe += p.x() ** 2
        y2Summe += p.y() ** 2
    xm = xSumme / len(points)
    ym = ySumme / len(points)
    sd = math.sqrt(x2Summe / len(points) - xm * xm + y2Summe / len(points) - ym * ym)
    for i in range(len(training)):
        summeDist = 0.0
        for j in range(len(training[i])):
            k = int(round((len(points)-1) * j / (len(training[i])-1)))
            pAktuell = (points[k] - core.QPointF(xm, ym)) * (1.0/sd)
            pMuster = (training[i][j] - trainingSchwerpunkte[i]) * (1.0/trainingSD[i])
            pDiff = pAktuell - pMuster
            dist = math.sqrt(pDiff.x() ** 2 + pDiff.y() ** 2)
            summeDist += dist
        mittlAbst = summeDist / len(training[i])
        print(f"Geste {i+1}: Abstand {mittlAbst:.2f}")
    points.clear()

w.widget.setHandlers(move, release)

w.show()
sys.exit(app.exec())